## dtkwidget 5.6.2.2+1

=== docs/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10)

find_package (Doxygen REQUIRED)

set (QCH_INSTALL_DESTINATION ${CMAKE_INSTALLL_PREFIX}/share/qt5/doc CACHE STRING "QCH install location")

set (DOXYGEN_GENERATE_HTML "YES" CACHE STRING "Doxygen HTML output")
set (DOXYGEN_GENERATE_XML "YES" CACHE STRING "Doxygen XML output")
set (DOXYGEN_GENERATE_QHP "YES" CACHE STRING "Doxygen QHP output")
set (DOXYGEN_FILE_PATTERNS *.cpp *.h *.zh_CN.md *.zh_CN.dox CACHE STRING "Doxygen File Patterns")
set (DOXYGEN_PROJECT_NUMBER ${CMAKE_PROJECT_VERSION} CACHE STRING "") # Should be the same as this project is using.
set (DOXYGEN_EXTRACT_STATIC YES)
set (DOXYGEN_OUTPUT_LANGUAGE "Chinese" CACHE STRING "Doxygen Output Language")
set (DOXYGEN_IMAGE_PATH ${CMAKE_CURRENT_LIST_DIR}/images/)
set (DOXYGEN_QHG_LOCATION "qhelpgenerator")
set (DOXYGEN_QHP_NAMESPACE "org.deepin.dtk.widget")
set (DOXYGEN_QCH_FILE "dtkwidget.qch")
set (DOXYGEN_QHP_VIRTUAL_FOLDER "dtkwidget")
set (DOXYGEN_HTML_EXTRA_STYLESHEET "" CACHE STRING "Doxygen custom stylesheet for HTML output")
set (DOXYGEN_TAGFILES "qtcore.tags=qthelp://org.qt-project.qtcore/qtcore/" CACHE STRING "Doxygen tag files")

set (DOXYGEN_PREDEFINED
    "D_DECL_DEPRECATED_X(x)="
    "\"DCORE_BEGIN_NAMESPACE=namespace Dtk { namespace Core {\""
    "\"DCORE_END_NAMESPACE=}}\""
    "\"DCORE_USE_NAMESPACE=using namespace Dtk::Core\;\""
    "\"DWIDGET_BEGIN_NAMESPACE=namespace Dtk { namespace Widget {\""
    "\"DWIDGET_END_NAMESPACE=}}\""
    "\"DWIDGET_USE_NAMESPACE=using namespace Dtk::Widget\;\""
)
if(BUILD_THEME)
set (DOXYGEN_HTML_EXTRA_STYLESHEET "docs/doxygentheme/doxygen-awesome.css"
                                "docs/doxygentheme/doxygen-awesome-sidebar-only.css"
                                "docs/doxygentheme/doxygen-awesome-sidebar-only-darkmode-toggle.css"
                                )
set (DOXYGEN_HTML_EXTRA_FILES "docs/doxygentheme/doxygen-awesome-darkmode-toggle.js"
                            "docs/doxygentheme/doxygen-awesome-fragment-copy-button.js"
                            "docs/doxygentheme/doxygen-awesome-paragraph-link.js"
                            "docs/doxygentheme/doxygen-awesome-interactive-toc.js"
                            )
set (DOXYGEN_GENERATE_TREEVIEW "YES")
set (DOXYGEN_DISABLE_INDEX "NO")
set (DOXYGEN_FULL_SIDEBAR "NO")
set (DOXYGEN_HTML_HEADER "docs/doxygentheme/header.html")
endif()

set (DOXYGEN_MACRO_EXPANSION "YES")
set (DOXYGEN_EXPAND_ONLY_PREDEF "YES")

doxygen_add_docs (doxygen
    ${PROJECT_SOURCE_DIR}/src
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/docs
    ALL
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    COMMENT "Generate documentation via Doxygen"
)

install (FILES ${PROJECT_BINARY_DIR}/docs/html/dtkwidget.qch DESTINATION ${QCH_INSTALL_DESTINATION})

=== plugin/CMakeLists.txt ===
add_subdirectory(dtkuidemo)
add_subdirectory(dtkuiplugin)

=== src/CMakeLists.txt ===
# SET the version
#cmake_minimum_required(VERSION 3.5)

set(LIB_NAME dtkwidget)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
# find_package 
find_package(DtkGui 5.6 REQUIRED)
find_package(DtkCore 5.6 REQUIRED)

find_package(Qt5 REQUIRED COMPONENTS Core)
find_package(Qt5 REQUIRED COMPONENTS Network)
find_package(Qt5 REQUIRED COMPONENTS Concurrent)
find_package(Qt5 REQUIRED COMPONENTS Widgets)
find_package(Qt5 REQUIRED COMPONENTS PrintSupport)
#find_package(Qt5 REQUIRED COMPONENTS Multimedia)
find_package(Qt5 REQUIRED COMPONENTS LinguistTools)

find_package(PkgConfig REQUIRED)

pkg_check_modules(QGSettings REQUIRED gsettings-qt)
pkg_check_modules(XCBUTIL REQUIRED xcb-util) 
pkg_check_modules(STARUPNOTIFICATION REQUIRED libstartup-notification-1.0)
pkg_check_modules(XEXT REQUIRED xext)
pkg_check_modules(XI REQUIRED xi)
pkg_check_modules(X11 REQUIRED x11)

include(util/util.cmake)
include(widgets/widgets.cmake)

#file(GLOB UTILHEAEDER ../include/dtkwidget/util/*.h)
if (UNIX AND NOT APPLE)
  set(LINUX TRUE)
endif()

set(CONFIGNAME ../include/dtkwidget/global/dtkwidget_config.h)
file(WRITE ${CONFIGNAME} "// it is auto make config\n")
file(GLOB CONFIGSOURCE ../include/dtkwidget/DWidget/*)

foreach(FILENAME ${CONFIGSOURCE})
  get_filename_component(thefile ${FILENAME} NAME)
  file(APPEND ${CONFIGNAME} "#define DTKWIDGET_CLASS_${thefile}\n")
endforeach()

file(GLOB TRANSLATE translations/*.ts)
qt5_add_translation(TRANSLATEDFILES ${TRANSLATE})

add_definitions(-DSN_API_NOT_YET_FROZEN)
add_definitions(-DDTK_NO_MULTIMEDIA)
#TranslateDir
add_definitions(-DDWIDGET_TRANSLATIONS_DIR="libdtk-${CMAKE_PROJECT_VERSION}/DWidget/translations")
find_package(Qt5 COMPONENTS X11Extras)
find_package(Qt5 COMPONENTS DBus)
add_library(${LIB_NAME} SHARED
  ${widgets_SRC}
  ${TRANSLATEDFILES}
  ${util_SRC}
)
target_link_libraries(
  ${LIB_NAME} PRIVATE
  Qt5::Widgets
  Qt5::Network
  Qt5::Concurrent
  Qt5::Core
  Qt5::DBus
  Qt5::X11Extras
  Qt5::PrintSupport
  ${DtkGui_LIBRARIES}
  ${DtkCore_LIBRARIES}
  ${QGSettings_LIBRARIES}
  ${STARUPNOTIFICATION_LIBRARIES}
  ${XEXT_LIBRARIES}
  ${XI_LIBRARIES}
  ${X11_LIBRARIES}
  ${XCBUTIL_LIBRARIES}
)
target_include_directories(${LIB_NAME} PUBLIC
  ../include/dtkwidget/DWidget/
  ../include/dtkwidget/util/
  ../include/dtkwidget/widgets/
  ../include/dtkwidget/global/
  ../include/

  ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
  ${Qt5Widgets_PRIVATE_INCLUDE_DIRS}
  ${Qt5PrintSupport_PRIVATE_INCLUDE_DIRS}
  ${QGSettings_INCLUDE_DIRS}
  ${STARUPNOTIFICATION_INCLUDE_DIRS}
  ${XEXT_INCLUDE_DIRS}
  ${XI_INCLUDE_DIRS}
  ${X11_INCLUDE_DIRS}
  ${XCBUTIL_INCLUDE_DIRS}
)
set_target_properties(${LIB_NAME} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
)
install(TARGETS ${LIB_NAME} DESTINATION ${LIBRARY_INSTALL_DIR})
install(DIRECTORY ../include/dtkwidget/DWidget/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*")
install(DIRECTORY ../include/dtkwidget/util/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*")
install(DIRECTORY ../include/dtkwidget/global/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*")
install(DIRECTORY ../include/dtkwidget/widgets/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*")

install(FILES ${TRANSLATEDFILES} DESTINATION "${CMAKE_INSTALL_DATADIR}/libdtk-${CMAKE_PROJECT_VERSION}/DWidget/translations")

=== tests/CMakeLists.txt ===
#cmake_minimum_required(VERSION 3.5)

set(BIN_NAME "ut-${PROJECT_NAME}")
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_CXX_FLAGS "-fno-access-control")
add_compile_options(-fsanitize=address)
add_link_options(-fsanitize=address)

add_definitions(-DSN_API_NOT_YET_FROZEN)
add_definitions(-DDTK_NO_MULTIMEDIA)
#TrainslateDir
add_definitions(-DDWIDGET_TRANSLATIONS_DIR="libdtk-${CMAKE_PROJECT_VERSION}/DWidget/translate")


find_package(DtkGui REQUIRED)
find_package(DtkCore REQUIRED)
#find_package(DtkWidget REQUIRED)

find_package(Qt5 REQUIRED COMPONENTS Core)
find_package(Qt5 REQUIRED COMPONENTS Test)
find_package(Qt5 REQUIRED COMPONENTS Network)
find_package(Qt5 REQUIRED COMPONENTS Concurrent)
find_package(Qt5 REQUIRED COMPONENTS Widgets)
find_package(Qt5 REQUIRED COMPONENTS PrintSupport)
#find_package(Qt5 REQUIRED COMPONENTS Multimedia)
find_package(Qt5 COMPONENTS X11Extras)
find_package(Qt5 COMPONENTS DBus)

find_package(GTest REQUIRED)
find_package(PkgConfig REQUIRED)

pkg_check_modules(QGSettings REQUIRED gsettings-qt)
pkg_check_modules(XCBUTIL REQUIRED xcb-util) 
pkg_check_modules(STARUPNOTIFICATION REQUIRED libstartup-notification-1.0)
pkg_check_modules(XEXT REQUIRED xext)
pkg_check_modules(XI REQUIRED xi)
pkg_check_modules(X11 REQUIRED x11)


set(WIDGET_TEST 
  testcases/widgets/ut_daboutdialog.cpp
  testcases/widgets/ut_dabstractdialog.cpp
  testcases/widgets/ut_dalertcontrol.cpp
  testcases/widgets/ut_danchor.cpp
  # TODO break the test
  #testcases/widgets/ut_danchors.cpp
  testcases/widgets/ut_darrowbutton.cpp
  testcases/widgets/ut_darrowlinedrawer.cpp
  testcases/widgets/ut_darrowlineexpand.cpp
  testcases/widgets/ut_darrowrectangle.cpp
  testcases/widgets/ut_dbackgroundgroup.cpp
  testcases/widgets/ut_dbaseexpand.cpp
  testcases/widgets/ut_dbaseline.cpp
  testcases/widgets/ut_dblureffectwidget.cpp
  testcases/widgets/ut_dboxwidget.cpp
  testcases/widgets/ut_dbuttonbox.cpp
  testcases/widgets/ut_dcircleprogress.cpp
  testcases/widgets/ut_dclipeffectwidget.cpp
  testcases/widgets/ut_dcoloredprogressbar.cpp
  testcases/widgets/ut_dcommandlinkbutton.cpp
  testcases/widgets/ut_dcrumbedit.cpp
  testcases/widgets/ut_ddialog.cpp
  testcases/widgets/ut_ddialogclosebutton.cpp
  testcases/widgets/ut_ddrawer.cpp
  testcases/widgets/ut_ddrawergroup.cpp
  testcases/widgets/ut_denhancedwidget.cpp
  # TODO test break
  #testcases/widgets/ut_dexpandgroup.cpp
  testcases/widgets/ut_dfilechooseredit.cpp
  testcases/widgets/ut_dfiledialog.cpp
  testcases/widgets/ut_dfloatingbutton.cpp
  testcases/widgets/ut_dfloatingmessage.cpp
  testcases/widgets/ut_dfloatingwidget.cpp
  # TODO break
  # testcases/widgets/ut_dflowlayout.cpp
  testcases/widgets/ut_dframe.cpp
  testcases/widgets/ut_dgraphicsclipeffect.cpp
  testcases/widgets/ut_dgraphicsgloweffect.cpp
  testcases/widgets/ut_dheaderline.cpp
  testcases/widgets/ut_diconbutton.cpp
  testcases/widgets/ut_dinputdialog.cpp
  testcases/widgets/ut_dipv4lineedit.cpp
  testcases/widgets/ut_dkeysequenceedit.cpp
  testcases/widgets/ut_dlabel.cpp
  testcases/widgets/ut_dlineedit.cpp
  testcases/widgets/ut_dlistview.cpp
  testcases/widgets/ut_dloadingindicator.cpp
  testcases/widgets/ut_dmainwindow.cpp
  testcases/widgets/ut_dmessagemanager.cpp
  testcases/widgets/ut_dmpriscontrol.cpp
  testcases/widgets/ut_dpageindicator.cpp
  testcases/widgets/ut_dpasswordedit.cpp
  testcases/widgets/ut_dpicturesequenceview.cpp
  # TODO PREAK
  #testcases/widgets/ut_dprintpickcolorwidget.cpp
  #testcases/widgets/ut_dprintpreviewdialog.cpp
  testcases/widgets/ut_dprintpreviewwidget.cpp
  testcases/widgets/ut_dprogressbar.cpp
  testcases/widgets/ut_dpushbutton.cpp
  #TODO BREAK kf.windowsystem: Could not find any platform plugin
  # testcases/widgets/ut_dsearchcombobox.cpp
  testcases/widgets/ut_dsearchedit.cpp
  testcases/widgets/ut_dsettingsdialog.cpp
  testcases/widgets/ut_dsettingswidgetfactory.cpp
  testcases/widgets/ut_dshaowline.cpp
  testcases/widgets/ut_dsimplelistview.cpp
  testcases/widgets/ut_dslider.cpp
  # TODO break
  #testcases/widgets/ut_dspinbox.cpp
  # testcases/widgets/ut_dspinner.cpp
  testcases/widgets/ut_dstackwidget.cpp
  testcases/widgets/ut_dstyleditemdelegate.cpp
  testcases/widgets/ut_dstyleoption.cpp
  testcases/widgets/ut_dsuggestbutton.cpp
  testcases/widgets/ut_dswitchbutton.cpp
  testcases/widgets/ut_dtabbar.cpp
  testcases/widgets/ut_dtextedit.cpp
  testcases/widgets/ut_dtickeffect.cpp
  testcases/widgets/ut_dtiplabel.cpp
  testcases/widgets/ut_dtitlebar.cpp
  testcases/widgets/ut_dtoolbutton.cpp
  testcases/widgets/ut_dtooltip.cpp
  testcases/widgets/ut_dwarningbutton.cpp
  # FIXME break
  # testcases/widgets/ut_dwaterprogress.cpp
  testcases/widgets/ut_dwindowclosebutton.cpp
  testcases/widgets/ut_dwindowmaxbutton.cpp
  testcases/widgets/ut_dwindowminbutton.cpp
  testcases/widgets/ut_dwindowoptionbutton.cpp
  testcases/widgets/ut_dwindowquitfullbutton.cpp
)

include(../src/util/util.cmake)
include(../src/widgets/widgets.cmake)

add_executable(${BIN_NAME}
  main.cpp
  ${util_SRC}
  ${widgets_SRC}
  ${WIDGET_TEST}
)
if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    target_compile_options(${BIN_NAME} PRIVATE -fprofile-instr-generate -ftest-coverage)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(${BIN_NAME} PRIVATE -fprofile-arcs -ftest-coverage)
endif()
target_link_libraries(${BIN_NAME} PRIVATE 
  Qt5::Test 
  Qt5::Widgets
  Qt5::Core
  Qt5::DBus
  Qt5::PrintSupport
  Qt5::Concurrent
  Qt5::X11Extras
  Qt5::Network
  #${GLIB_LDFLAGS}
  ${QGSettings_LIBRARIES}
  ${STARUPNOTIFICATION_LIBRARIES}
  ${XEXT_LIBRARIES}
  ${XI_LIBRARIES}
  ${DtkGui_LIBRARIES}
  ${DtkCore_LIBRARIES}
  ${GTEST_LIBRARIES}
  ${X11_LIBRARIES}
  ${XCBUTIL_LIBRARIES}
  -lpthread
  -lm
  -lgcov
)
target_include_directories(${BIN_NAME} PUBLIC 
  ../include/dtkwidget/util/
  ../include/dtkwidget/global/
  ../include/dtkwidget/DWidget/
  ../include/dtkwidget/widgets/
  ../include/
  ../src/widgets/
  #../src/platforms/x11
  ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
  ${Qt5Widgets_PRIVATE_INCLUDE_DIRS}
  ${Qt5PrintSupport_PRIVATE_INCLUDE_DIRS}
  ${QGSettings_INCLUDE_DIRS}
  ${STARUPNOTIFICATION_INCLUDE_DIRS}
  ${XEXT_INCLUDE_DIRS}
  ${XI_INCLUDE_DIRS}
  ${X11_INCLUDE_DIRS}
  ${XCBUTIL_INCLUDE_DIRS}
  #${GLIB_INCLUDE_DIRS}
)
add_test(NAME ${BIN_NAME} COMMAND ${BIN_NAME})

=== tools/CMakeLists.txt ===
#cmake_minimum_required(VERSION 3.5)
set(BIN_NAME dtk-svgc)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_SHARED_LINKER_FLAGS ${CMAKE_SHARED_LINKER_FLAGS} "-Wl,--as-needed")
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
# find_package 
find_package(DtkGui REQUIRED)
#find_package(DtkCore REQUIRED)

#find_package(Qt5 REQUIRED COMPONENTS Core)
#find_package(Qt5 REQUIRED COMPONENTS Widgets)
find_package(Qt5 REQUIRED COMPONENTS Svg)

add_executable(
  ${BIN_NAME}
  svgc/main.cpp
)
target_link_libraries(
  ${BIN_NAME} PRIVATE
  #Qt5::Core
  Qt5::Svg
  ${DtkGui_LIBRARIES}
  #  ${DtkCore_LIBRARIES}
)
install(TARGETS ${BIN_NAME} DESTINATION "${TOOL_INSTALL_DIR}")

=== plugin/dtkuidemo/CMakeLists.txt ===
#cmake_minimum_required(VERSION 3.5)

#project(dtkuidemo VERSION 0.1 LANGUAGES CXX)
set(DEMO dtkuidemo)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)


find_package(DtkGui REQUIRED)
#find_package(DtkWidget REQUIRED)
find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Widgets)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Widgets)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)
set(RCC_FILES dtkuidemo.qrc)
add_executable(
  ${DEMO}
  main.cpp 
  mainwindow.h
  mainwindow.cpp
  mainwindow.ui
  ${RCC_FILES}
)
target_link_libraries(
  ${DEMO} PRIVATE 
  dtkwidget
  Qt${QT_VERSION_MAJOR}::Widgets
  Qt${QT_VERSION_MAJOR}::Core
  ${DtkGui_LIBRARIES}
)
target_include_directories(${DEMO} PUBLIC
  #${DtkWidget_INCLUDE_DIRS}
  ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
  ../../../include/dtkwidget/DWidget/
  ../../../include/dtkwidget/widgets/
  ../../../include/dtkwidget/util/
  ../../../include/dtkwidget/global/
)

=== plugin/dtkuiplugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

set(UIPLUGIN dtkuiplugin)
project(${UIPLUGIN} VERSION 1.0.0 LANGUAGES CXX)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(DtkGui REQUIRED)
find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Widgets)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Widgets)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS UiPlugin)

set(LIB_DWIDGET dtkwidget)
set(INC_DWIDGET)
if (CMAKE_PROJECT_NAME STREQUAL ${UIPLUGIN})
    message("compile ${UIPLUGIN} individually")
    include(GNUInstallDirs)
    if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
        set(CMAKE_INSTALL_PREFIX /usr)
    endif ()
    find_package(DtkWidget REQUIRED)
    set(LIB_DWIDGET ${DtkWidget_LIBRARIES})
    set(INC_DWIDGET ${DTKWIDGET_INCLUDE_DIR})
else()
    list(APPEND INC_DWIDGET ${CMAKE_CURRENT_LIST_DIR}/../../../include/dtkwidget/DWidget)
    list(APPEND INC_DWIDGET ${CMAKE_CURRENT_LIST_DIR}/../../../include/dtkwidget/widgets)
    list(APPEND INC_DWIDGET ${CMAKE_CURRENT_LIST_DIR}/../../../include/dtkwidget/util)
    list(APPEND INC_DWIDGET ${CMAKE_CURRENT_LIST_DIR}/../../../include/dtkwidget/global)
endif()

set(RCC_FILES dtkuiplugin.qrc)
add_library(
    ${UIPLUGIN} SHARED
    dcustomerplugins.h
    dcustomerplugins.cpp
    dcustomermacrowidget.h
    ${RCC_FILES}
)

target_link_libraries(
    ${UIPLUGIN} PRIVATE
    ${LIB_DWIDGET}
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::UiPlugin
)

target_include_directories(${UIPLUGIN} PUBLIC
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${INC_DWIDGET}
)

set (INSTALL_PLUGIN OFF CACHE BOOL "install dtk designer plugin")
if (INSTALL_PLUGIN)
    set(QT_PLUGIN_DESIGNER_PATH "qt5/plugins/designer/")
    install(TARGETS ${UIPLUGIN} DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}/${QT_PLUGIN_DESIGNER_PATH}")
    message("install path:" "${CMAKE_INSTALL_FULL_LIBDIR}/${QT_PLUGIN_DESIGNER_PATH}")
endif()

=== examples/dwidget-examples/collections/CMakeLists.txt ===
#cmake_minimum_required(VERSION 3.5)
#project(collections)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(BIN_NAME collections)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)


find_package(DtkGui REQUIRED)
find_package(DtkCore REQUIRED)
#find_package(DtkWidget REQUIRED)

find_package(Qt5 REQUIRED COMPONENTS Core)
find_package(Qt5 REQUIRED COMPONENTS Widgets)
#find_package(Qt5 REQUIRED COMPONENTS Svg)
find_package(Qt5 REQUIRED COMPONENTS PrintSupport)

set(IMAGES images.qrc)
set(RESCOUCES resources.qrc)
set(THEME icons/theme-icons.qrc)
add_executable(${BIN_NAME}
  ${IMAGES}
  ${RESCOUCES}
  ${THEME}
  cameraform.ui

  mainwindow.h 
  buttonexample.h 
  examplewindowinterface.h 
  pagewindowinterface.h 
  editexample.h 
  sliderexample.h 
  listviewexample.h 
  windowexample.h 
  tooltipexample.h 
  spinnerexample.h 
  dialogexample.h 
  progressbarexample.h 
  layoutexample.h 
  scrollbarexample.h 
  rubberbandexample.h 
  widgetexample.h 
  lcdnumberexample.h 
  menuexample.h

  main.cpp
  mainwindow.cpp 
  buttonexample.cpp 
  examplewindowinterface.cpp 
  pagewindowinterface.cpp 
  editexample.cpp 
  sliderexample.cpp 
  listviewexample.cpp 
  windowexample.cpp 
  tooltipexample.cpp 
  spinnerexample.cpp 
  dialogexample.cpp 
  progressbarexample.cpp 
  layoutexample.cpp 
  scrollbarexample.cpp 
  rubberbandexample.cpp 
  widgetexample.cpp 
  lcdnumberexample.cpp 
  menuexample.cpp
)
target_link_libraries(${BIN_NAME} PRIVATE 
  Qt5::Widgets
  Qt5::Core
  #  Qt5::Svg
  Qt5::PrintSupport
  dtkwidget
  ${DtkGui_LIBRARIES}
  ${DtkCore_LIBRARIES}
)
target_include_directories(${BIN_NAME} PUBLIC
  ../../../include/dtkwidget/DWidget/
  ../../../include/dtkwidget/widgets/
  ../../../include/dtkwidget/util/
  ../../../include/dtkwidget/global/
  ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
)
install(TARGETS ${BIN_NAME} DESTINATION "${CMAKE_INSTALL_LIBDIR}/libdtk-${CMAKE_PROJECT_VERSION}/DWidget/examples/")

=== debian/changelog ===
dtkwidget (5.6.2.2+1-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Thu, 01 Dec 2022 22:43:55 +0800

dtkwidget (5.6.2.2) unstable; urgency=medium

  * Release 5.6.2.2

 -- Deepin Packages Builder <packages@deepin.com>  Wed, 30 Nov 2022 10:41:14 +0800

## dtkwidget 5.6.4

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10)

set (DVERSION "5.6.2" CACHE STRING "define project version")
project (DtkWidget
  VERSION ${DVERSION}
  DESCRIPTION "DTK Widget module"
  HOMEPAGE_URL "https://github.com/linuxdeepin/dtkwidget"
  LANGUAGES CXX C
)
#set(BREAKVERSION "5")
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

# Set build option
set (BUILD_PLUGINS ON CACHE BOOL "BUILD PLUGIN EXAMPLES")

# Set install path
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()
set (INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_FULL_INCLUDEDIR}/libdtk-${CMAKE_PROJECT_VERSION}/DWidget")
set (TOOL_INSTALL_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/libdtk-${CMAKE_PROJECT_VERSION}/DWidget/bin")
set (LIBRARY_INSTALL_DIR "${CMAKE_INSTALL_FULL_LIBDIR}")
set (MKSPECS_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt5/mkspecs/modules" CACHE STRING "INSTALL DIR FOR qt pri files")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed")
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(BUILD_TESTING ON)
else ()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")
endif ()


add_subdirectory(src)

add_subdirectory(examples)
add_subdirectory(tools)

if(BUILD_TESTING)
  message("==================================")
  message("       Now Testing is enabled     ")
  message("==================================")
  enable_testing()
  add_subdirectory(tests)
endif()
if(BUILD_PLUGINS)
  message("===================================")
  message(" You can build and run plugins now ")
  message("===================================")
  add_subdirectory(plugin)
endif()
find_package (Qt5 CONFIG REQUIRED COMPONENTS DBus Xml)

set (BUILD_DOCS ON CACHE BOOL "Generate doxygen-based documentation")

if (BUILD_DOCS)
  add_subdirectory(docs)
endif ()

configure_package_config_file(misc/DtkWidgetConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/DtkWidgetConfig.cmake
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/DtkWidget"
    PATH_VARS INCLUDE_INSTALL_DIR LIBRARY_INSTALL_DIR TOOL_INSTALL_DIR
)
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/DtkWidgetConfigVersion.cmake"
    VERSION ${DVERSION}
    COMPATIBILITY SameMajorVersion
)
install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/DtkWidgetConfig.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/DtkWidgetConfigVersion.cmake
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/DtkWidget"
)

configure_file(misc/dtkwidget.pc.in dtkwidget.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dtkwidget.pc DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

configure_file(misc/qt_lib_dtkwidget.pri.in qt_lib_dtkwidget.pri @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qt_lib_dtkwidget.pri DESTINATION "${MKSPECS_INSTALL_DIR}")

=== docs/CMakeLists.txt ===
--- 
+++ 
@@ -28,24 +28,46 @@
     "\"DWIDGET_END_NAMESPACE=}}\""
     "\"DWIDGET_USE_NAMESPACE=using namespace Dtk::Widget\;\""
 )
+
+set (BUILD_THEME OFF CACHE BOOL "Build doxgen theme")
 if(BUILD_THEME)
-set (DOXYGEN_HTML_EXTRA_STYLESHEET "docs/doxygentheme/doxygen-awesome.css"
-                                "docs/doxygentheme/doxygen-awesome-sidebar-only.css"
-                                "docs/doxygentheme/doxygen-awesome-sidebar-only-darkmode-toggle.css"
+if(EXISTS "${CMAKE_CURRENT_LIST_DIR}/doxygen-theme")
+message(STATUS "doxygen-theme exist")
+else()
+execute_process(COMMAND git clone https://github.com/linuxdeepin/doxygen-theme.git --depth=1
+        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
+        TIMEOUT 60
+    )
+execute_process(COMMAND bash themesetting.sh
+        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/doxygen-theme/
+)
+endif()
+set (DOXYGEN_HTML_EXTRA_STYLESHEET "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome.css"
+                                "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-sidebar-only.css"
+                                "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-sidebar-only-darkmode-toggle.css"
                                 )
-set (DOXYGEN_HTML_EXTRA_FILES "docs/doxygentheme/doxygen-awesome-darkmode-toggle.js"
-                            "docs/doxygentheme/doxygen-awesome-fragment-copy-button.js"
-                            "docs/doxygentheme/doxygen-awesome-paragraph-link.js"
-                            "docs/doxygentheme/doxygen-awesome-interactive-toc.js"
+set (DOXYGEN_HTML_EXTRA_FILES "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-darkmode-toggle.js"
+                            "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-fragment-copy-button.js"
+                            "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-paragraph-link.js"
+                            "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-interactive-toc.js"
                             )
 set (DOXYGEN_GENERATE_TREEVIEW "YES")
 set (DOXYGEN_DISABLE_INDEX "NO")
 set (DOXYGEN_FULL_SIDEBAR "NO")
-set (DOXYGEN_HTML_HEADER "docs/doxygentheme/header.html")
+set (DOXYGEN_HTML_HEADER "docs/doxygen-theme/doxygen-awesome-css/header.html")
+set (DOXYGEN_HTML_FOOTER "docs/doxygen-theme/doxygen-awesome-css/footer.html")
 endif()
 
 set (DOXYGEN_MACRO_EXPANSION "YES")
 set (DOXYGEN_EXPAND_ONLY_PREDEF "YES")
+
+# Exclude private classes.
+set(DOXYGEN_EXCLUDE_PATTERNS
+    ${PROJECT_SOURCE_DIR}/src/widgets/private/dimageviewer_p.h
+    ${PROJECT_SOURCE_DIR}/src/widgets/private/dimagevieweritems_p.h
+    ${PROJECT_SOURCE_DIR}/src/widgets/private/dsplitscreen_p.h
+    ${PROJECT_SOURCE_DIR}/src/widgets/dimagevieweritems.cpp
+)
 
 doxygen_add_docs (doxygen
     ${PROJECT_SOURCE_DIR}/src

=== examples/CMakeLists.txt ===
add_subdirectory(dwidget-examples/collections)
add_subdirectory(dwidget-examples/PrintPreviewSettingsPlugin)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -13,8 +13,7 @@
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 # find_package 
-find_package(DtkGui 5.6 REQUIRED)
-find_package(DtkCore 5.6 REQUIRED)
+find_package(Dtk REQUIRED COMPONENTS Core Gui)
 
 find_package(Qt5 REQUIRED COMPONENTS Core)
 find_package(Qt5 REQUIRED COMPONENTS Network)
@@ -110,3 +109,5 @@
 install(DIRECTORY ../include/dtkwidget/widgets/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*")
 
 install(FILES ${TRANSLATEDFILES} DESTINATION "${CMAKE_INSTALL_DATADIR}/libdtk-${CMAKE_PROJECT_VERSION}/DWidget/translations")
+
+DCONFIG_META_FILES(COMMONID org.deepin.dtkwidget FILES "./org.deepin.dtkwidget.feature-display.json")

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -82,6 +82,7 @@
   testcases/widgets/ut_dgraphicsgloweffect.cpp
   testcases/widgets/ut_dheaderline.cpp
   testcases/widgets/ut_diconbutton.cpp
+  testcases/widgets/ut_dimageviewer.cpp
   testcases/widgets/ut_dinputdialog.cpp
   testcases/widgets/ut_dipv4lineedit.cpp
   testcases/widgets/ut_dkeysequenceedit.cpp

=== plugin/dtkuiplugin/CMakeLists.txt ===
--- 
+++ 
@@ -52,6 +52,7 @@
     Qt${QT_VERSION_MAJOR}::Widgets
     Qt${QT_VERSION_MAJOR}::Core
     Qt${QT_VERSION_MAJOR}::UiPlugin
+    Dtk::Gui
 )
 
 target_include_directories(${UIPLUGIN} PUBLIC

=== examples/dwidget-examples/PrintPreviewSettingsPlugin/CMakeLists.txt ===
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(LIB_NAME PrintPreviewSettingsPlugin)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)


find_package(DtkGui REQUIRED)
find_package(DtkCore REQUIRED)
#find_package(DtkWidget REQUIRED)

find_package(Qt5 REQUIRED COMPONENTS Core)
find_package(Qt5 REQUIRED COMPONENTS Widgets)
#find_package(Qt5 REQUIRED COMPONENTS Svg)
find_package(Qt5 REQUIRED COMPONENTS PrintSupport)

add_library(${LIB_NAME} SHARED 
  settingsplugin.h 
  settingsplugin.cpp
)
target_link_libraries(${LIB_NAME} PRIVATE 
  Qt5::Widgets
  Qt5::Core
  #  Qt5::Svg
  Qt5::PrintSupport
  dtkwidget
  ${DtkGui_LIBRARIES}
  ${DtkCore_LIBRARIES}
)
target_include_directories(${LIB_NAME} PUBLIC
  ../../../include/dtkwidget/DWidget/
  ../../../include/dtkwidget/widgets/
  ../../../include/dtkwidget/util/
  ../../../include/dtkwidget/global/
)

=== examples/dwidget-examples/collections/CMakeLists.txt ===
--- 
+++ 
@@ -48,6 +48,7 @@
   widgetexample.h 
   lcdnumberexample.h 
   menuexample.h
+  imageviewerexample.h
 
   main.cpp
   mainwindow.cpp 
@@ -68,6 +69,7 @@
   widgetexample.cpp 
   lcdnumberexample.cpp 
   menuexample.cpp
+  imageviewerexample.cpp
 )
 target_link_libraries(${BIN_NAME} PRIVATE 
   Qt5::Widgets
@@ -86,3 +88,4 @@
   ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
 )
 install(TARGETS ${BIN_NAME} DESTINATION "${CMAKE_INSTALL_LIBDIR}/libdtk-${CMAKE_PROJECT_VERSION}/DWidget/examples/")
+dconfig_override_files(APPID dtk-example META_NAME org.deepin.dtkwidget.feature-display FILES ./org.deepin.dtkwiget.feature-display.json)

=== debian/changelog ===
dtkwidget (5.6.4-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 17 Jan 2023 13:22:48 +0800

dtkwidget (5.6.4) unstable; urgency=medium

  * Release 5.6.4

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 10 Jan 2023 10:36:48 +0800

dtkwidget (5.6.3) unstable; urgency=medium

  * Release 5.6.3

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 12 Dec 2022 15:26:28 +0800

=== debian/control ===
Source: dtkwidget
Section: libdevel
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: debhelper (>= 9), pkg-config, libudev-dev,
 libqt5x11extras5-dev, libxext-dev, qttools5-dev-tools, qttools5-dev,
 x11proto-xext-dev, libxcb-util0-dev, libstartup-notification0-dev,
 libmtdev-dev, qtbase5-private-dev, libegl1-mesa-dev, libudev-dev,
 libfontconfig1-dev, libfreetype6-dev, libglib2.0-dev, libxrender-dev,
 libdtkcore-dev, libgsettings-qt-dev, libqt5svg5-dev, libxi-dev,
 libdtkgui-dev, libcups2-dev, libgtest-dev, libdtkcore5-bin, cmake, doxygen
Standards-Version: 3.9.8

Package: libdtkwidget5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdtkcommon,
  libqt5widgets5(>= 5.11.3.33) | libqt5widgets5(<= 5.11.3.28)
Multi-Arch: same
Description: Deepin graphical user interface library
 DtkWidget is Deepin graphical user interface for deepin desktop development.
 .
 This package contains the shared libraries.

Package: libdtkwidget5-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libdtkwidget5( =${binary:Version}),
 libqt5x11extras5-dev, libdtkcore-dev, libqt5svg5-dev
Description: Deepin graphical user interface library utilities
 DtkWidget is Deepin graphical user interface for deepin desktop development.
 .
 This package contains the utilities which are
 needed for developing Deepin applications.

Package: libdtkwidget-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libdtkwidget5( =${binary:Version}),
 libqt5x11extras5-dev, libdtkcore-dev, libqt5svg5-dev,
 libdtkgui-dev, libcups2-dev
Description: Deepin graphical user interface library
 DtkWidget is Deepin graphical user interface for deepin desktop development.
 .
 This package contains the header files and static libraries which are
 needed for developing Deepin applications.

Package: dtkwidget5-examples
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libdtkwidget5( =${binary:Version})
Description: dtkwidget-examples is generated by dtkwidget.
 DtkWidget is Deepin graphical user interface for deepin desktop development.
 .
 This package contains example application which are
 needed for developing Deepin applications.

Package: dtkwidget-doc
Architecture: any
Description: Deepin graphical user interface library (Document)
 DtkWidget is Deepin graphical user interface for deepin desktop development.
 .
 This package contains example application which are
 needed for developing Deepin applications.

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
export QT_SELECT = qt5

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

VERSION = $(DEB_VERSION_UPSTREAM)
_PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')
_BUILD_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$2}' | sed 's/[^0-9]//g' | awk '{print int($$1)}')
ifeq ($(_BUILD_VER),)
	CONFIG_VERSION = $(_PACK_VER)
else
	CONFIG_VERSION = $(_PACK_VER).$(_BUILD_VER)
endif

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_PLUGINS=OFF -DBUILD_DOCS=OFF -DDVERSION=$(_PACK_VER)
#override_dh_auto_configure:
#	dh_auto_configure -- LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)
#override_dh_makeshlibs:
#	dh_makeshlibs -V

#ifeq ($(DEB_BUILD_ARCH), sw_64)
#override_dh_makeshlibs:
#	dh_makeshlibs -V -- -c0
#endif

override_dh_makeshlibs:
	dh_makeshlibs  -V "libdtkwidget5 (>= $(shell echo $(VERSION) | cut -d '.' -f 1,2))"
